PROGRAM FARRIS (INFILE, OUTPUT);
CONST   WIDTH = 73;     (* FORM WIDTH *)
        NMLNGTH = 10;   (* LENGTH OF A SPECIES NAME *)
        MAXSPP = 50;    (* MAXIMUM NUMBER OF SPECIES *)
        MAXCHARS = 190; (* MAXIMUM NUMBER OF CHARACTERS *)
        MAXRANGE = 190; (* MAXIMUM OF MAXSPP, MAXCHARS *)
        BITS = 30;      (* NUMBER OF ELEMENTS IN A PASCAL SET *)
        WRDS = 7;       (* BITS * WRDS >= MAXRANGE *)
TYPE    BITRANGE = 1..BITS;
        BITSET = SET OF BITRANGE;
        STATESET = ARRAY [1..WRDS] OF BITSET;
        SETARRAY = ARRAY [1..MAXRANGE] OF STATESET;
        NAME = RECORD
           TEKST : ARRAY [1..NMLNGTH] OF CHAR;
           LENGTH : INTEGER;
           END;
        NAMEARRAY = ARRAY [1..MAXSPP] OF NAME;
VAR     INFILE : TEXT;
        M, J : STATESET;
        CHRSETS, SPPSETS : SETARRAY;
        NAMES : NAMEARRAY;
        I, K, SPP, CHARS, MIN, MAX, LARGEST : INTEGER;
        (* SPP = NUMBER OF SPECIESS
           CHARS = NUMBER OF CHARACTERS
           MIN = MINIMUM NUMBER OF MEMBERS IN A GROUP
           MAX = MAXIMUM NUMBER OF MEMBERS IN A GROUP *)
        SPECIES : BOOLEAN;
        (* TRUE IF THE MONOTHETIC GROUPS' MEMBERS ARE SPECIES,
           THEIR DISTINGUISHING SETS' MEMBERS ARE CHARACTERS *)
FUNCTION FIELD (I : INTEGER) : INTEGER;
        (* RETURNS THE FIELD WIDTH OF A POSITIVE INTEGER *)
        VAR F : INTEGER;
        BEGIN (* FIELD *)
        IF I<10 THEN F := 1
        ELSE IF I<100 THEN F := 2
           ELSE F := 3;
        FIELD := F;
        END; (* FIELD *)
FUNCTION WORD (I : INTEGER) : INTEGER;
        (* MAPS I TO ITS APPROPRIATE WORD IN A STATESET *)
        BEGIN (* WORD *)
        WORD := (I-1) DIV BITS + 1;
        END; (* WORD *)
FUNCTION BIT (I : INTEGER) : BITRANGE;
        (* MAPS I TO THE APPROPRIATE ELEMENT IN THE WORD *)
        BEGIN (* BIT *)
        BIT := (I-1) MOD BITS + 1;
        END; (* BIT *)
PROCEDURE GETCHRSETS (VAR SPP, CHARS: INTEGER; VAR NAMES :
                      NAMEARRAY; VAR CHRSETS : SETARRAY);
        (*  FORMS THE CHARACTER SETS AND PRINTS THE INPUT DATA *)
        VAR I, J, K : INTEGER;
            CH : CHAR;
            BADCHRS : BOOLEAN;
        FUNCTION SKIPJUNK : CHAR;
                (* RETURNS THE NEXT MEANINGFUL CHARACTER READ *)
                VAR FNCTN : CHAR;
                BEGIN (* SKIPJUNK *)
                REPEAT
                   READ (INFILE, FNCTN);
                UNTIL (FNCTN IN ['0', '1', 'B', 'P', '?']);
                SKIPJUNK := FNCTN;
                END; (* SKIPJUNK *)
        BEGIN (* GETCHRSETS *)
        WRITELN;
        READLN (INFILE, SPP, CHARS);
        BADCHRS := FALSE;
        FOR I := 1 TO SPP DO BEGIN
           WRITE(' ');
           FOR J := 1 TO NMLNGTH DO BEGIN
             READ (INFILE, NAMES [I] . TEKST [J]);
             WRITE(NAMES [I] . TEKST [J]);
             IF NAMES [I] . TEKST [J] <> ' '
             THEN NAMES [I] . LENGTH := J;
             END;
           WRITE('  ');
           FOR J := 1 TO WORD (CHARS) DO CHRSETS [I, J] := [];
           FOR J := 1 TO CHARS DO BEGIN
             IF EOLN(INFILE) THEN BEGIN;
                READLN (INFILE);
                WRITELN;
                WRITE(' ');
                FOR K := 1 TO NMLNGTH DO WRITE(' ');
                END;
             CH := SKIPJUNK;
             IF CH = '1'
             THEN BEGIN
                CHRSETS [I, WORD (J)] :=
                CHRSETS [I, WORD (J)] + [BIT (J)];
                WRITE('1');
                END
             ELSE BEGIN
                BADCHRS := BADCHRS OR (CH IN ['B', 'P', '?']);
                WRITE(CH);
                END;
             IF J MOD 5 = 0 THEN WRITE(' ');
             IF (J MOD 50) = 0 THEN BEGIN
                WRITELN;
                WRITE('            ');
                END;
             END;
           READLN (INFILE);
           WRITELN;
           END;
        WRITELN;
        IF BADCHRS
        THEN BEGIN
           WRITELN(' SOME STATES OTHER THAN 0 OR 1 WERE ENCOUNTERED');
           WRITELN(' THESE WERE SET TO 0');
           WRITELN;
           END;
        END; (* GETCHRSETS *)
PROCEDURE INVERT (CHRSETS : SETARRAY; VAR SPPSETS : SETARRAY);
        (* CONSTRUCTS THE SPECIES SETS FROM THE CHARACTER SETS *)
        VAR I, J : INTEGER;
        BEGIN (* INVERT *)
        FOR I := 1 TO CHARS DO BEGIN
           FOR J := 1 TO WORD (SPP) DO SPPSETS [I, J] := [];
           FOR J := 1 TO SPP DO
             IF BIT (I) IN CHRSETS [J, WORD (I)]
             THEN SPPSETS [I, WORD (J)] :=
                   SPPSETS [I, WORD (J)] + [BIT (J)];
           END;
        END; (* INVERT *)
PROCEDURE PRINTCHR (X : STATESET; SPECIES : BOOLEAN);
        (* PRINTS THE INDICES OF THE CHARACTERS IN A STATESET *)
        VAR I, J, PRINTED : INTEGER;
            FIRST : BOOLEAN;
        BEGIN (* PRINTCHR *)
        FIRST := TRUE;
        PRINTED := 18;
        J := 0;
        FOR I := 1 TO CHARS DO
           IF BIT (I) IN X [WORD(I)] THEN
              J := J + 1;
        WRITE(' ', J:4, ' CHARACTERS: ');
        FOR I := 1 TO CHARS DO
           IF BIT (I) IN X [WORD (I)] THEN BEGIN
             IF NOT FIRST THEN BEGIN
                WRITE(',');
                PRINTED := PRINTED + 1;
                END;
             IF PRINTED + FIELD (I) + 2 <= WIDTH
             THEN BEGIN
                WRITE(' ');
                PRINTED := PRINTED + FIELD (I) + 1;
                END
             ELSE BEGIN
                WRITELN;
                WRITE(' ');
                WRITE('           ');
                PRINTED := FIELD (I) + 11;
                END;
             WRITE(I : FIELD (I));
             IF FIRST THEN FIRST := FALSE;
             END;
        WRITE('.');
        WRITELN;
        END; (* PRINTCHR *)
PROCEDURE PRINTSPP (X : STATESET; SPECIES : BOOLEAN);
        (* PRINTS THE NAMES OF THE SPECIES IN A STATESET *)
        VAR I, J, K, L, PRINTED : INTEGER;
            FIRST : BOOLEAN;
        BEGIN (* PRINTSPP *)
        FIRST := TRUE;
        PRINTED := 18;
        J := 0;
        FOR I := 1 TO SPP DO
           IF BIT (I) IN X [WORD(I)] THEN J := J + 1;
        WRITE(' ', J: 4, ' SPECIES:  ');
        FOR I := 1 TO SPP DO
           IF BIT (I) IN X [WORD (I)] THEN BEGIN
             IF FIRST THEN WRITE(' ');
             IF NOT FIRST THEN BEGIN
                WRITE(',');
                PRINTED := PRINTED + 1;
                END;
             J := NAMES [I] . LENGTH;
             IF PRINTED + J + 2 <= WIDTH
             THEN BEGIN
                WRITE(' ');
                PRINTED := PRINTED + J + 1;
                END
             ELSE BEGIN
                WRITELN;
                WRITE(' ');
                WRITE('           ');
                PRINTED := J + 11;
                END;
             FOR K := 1 TO J DO
                WRITE(NAMES [I] . TEKST [K]);
             IF FIRST THEN FIRST := FALSE;
             END;
        WRITELN;
        END; (* PRINTSPP *)
FUNCTION COUNT (X : STATESET; SPECIES : BOOLEAN) : INTEGER;
        (* RETURNS THE NUMBER OF ELEMENTS IN A STATESET *)
        VAR I, RANGE, FNCTN : INTEGER;
        BEGIN (* COUNT *)
        IF SPECIES
        THEN RANGE := CHARS
        ELSE RANGE := SPP;
        FNCTN := 0;
        FOR I := 1 TO RANGE DO
           IF BIT (I) IN X [WORD (I)]
           THEN FNCTN := FNCTN + 1;
        COUNT := FNCTN;
        END; (* COUNT *)
FUNCTION SUBSET (X, Y : STATESET; SPECIES : BOOLEAN) : BOOLEAN;
        (* TRUE IF X IS CONTAINED IN Y *)
        VAR I, RANGE : INTEGER;
            FNCTN : BOOLEAN;
        BEGIN (* SUBSET *)
        IF SPECIES
        THEN RANGE := SPP
        ELSE RANGE := CHARS;
        FNCTN := TRUE;
        FOR I := 1 TO RANGE DO
           IF BIT (I) IN X [WORD (I)]
           THEN IF NOT (BIT (I) IN Y [WORD (I)])
             THEN FNCTN := FALSE;
        SUBSET := FNCTN;
        END; (* SUBSET *)
FUNCTION EQUAL (X, Y : STATESET; SPECIES : BOOLEAN) : BOOLEAN;
        (* TRUE IF X AND Y CONTAIN THE SAME MEMBERS *)
        BEGIN (* EQUAL *)
        EQUAL := (SUBSET (X, Y, SPECIES))
             AND (SUBSET (Y, X, SPECIES));
        END; (* EQUAL *)
PROCEDURE INTERSECT (X : STATESET; VAR Y : STATESET;
                     SPECIES : BOOLEAN);
        (* SETS Y TO THE INTERSECTION OF ALL STATESETS
           INDEXED BY VALUES IN X *)
        VAR I, J, RANGE1, RANGE2 : INTEGER;
            SETS : SETARRAY;
        BEGIN (* INTERSECT *)
        IF SPECIES THEN BEGIN
           RANGE1 := SPP;
           RANGE2 := CHARS;
           SETS := SPPSETS
           END
        ELSE BEGIN
           RANGE1 := CHARS;
           RANGE2 := SPP;
           SETS := CHRSETS;
           END;
        FOR I := 1 TO WORD (RANGE1) DO Y [I] := [];
        IF NOT (COUNT (X, SPECIES) = 0)
        THEN BEGIN
           FOR I := 1 TO RANGE1 DO
             Y [WORD (I)] := Y [WORD (I)] + [BIT (I)];
           FOR I := 1 TO RANGE2 DO
             IF BIT (I) IN X [WORD (I)]
             THEN FOR J := 1 TO WORD (RANGE1) DO
                Y [J] := Y [J] * SETS [I, J];
           END;
        END; (* INTERSECT *)
FUNCTION CHECK (X, Y : STATESET; SPECIES : BOOLEAN) : BOOLEAN;
        (* TRUE IF Y IS CONTAINED IN THE STATESET
           OF ANY INDEX IN X *)
        VAR I, RANGE : INTEGER;
            SETS : SETARRAY;
            FNCTN : BOOLEAN;
        BEGIN (* CHECK *)
        FNCTN := FALSE;
        IF SPECIES THEN BEGIN
           RANGE := CHARS;
           SETS := SPPSETS;
           END
        ELSE BEGIN
           RANGE := SPP;
           SETS := CHRSETS;
           END;
        FOR I := 1 TO RANGE DO
           IF BIT (I) IN X [WORD (I)]
           THEN IF SUBSET (Y, SETS [I], SPECIES)
             THEN FNCTN := TRUE;
        CHECK := FNCTN;
        END; (* CHECK *)
PROCEDURE GEN (M, J : STATESET; K, MIN, MAX : INTEGER;
               SPECIES : BOOLEAN);
        (* RECURSIVELY PRODUCES ALL MONOTHETIC GROUPS *)
        VAR I, RANGE, CNT : INTEGER;
            L, C1, C2, C3 : STATESET;
        BEGIN (* GEN *)
        IF SPECIES
        THEN RANGE := CHARS
        ELSE RANGE := SPP;
        FOR I := 1 TO WRDS DO C1[I] := [];
        FOR I := 1 TO WRDS DO C2[I] := [];
        I := K;
        C2 [1] := [1]; (* SO C1 <> C2 AT NEXT LINE *)
        WHILE (I <= RANGE) AND (NOT EQUAL (C1, C2, SPECIES))
        DO BEGIN
           L := J;
           L [WORD (I)] := L [WORD (I)] + [BIT (I)];
           INTERSECT (L, C1, SPECIES);
           CNT := COUNT (C1, SPECIES);
           IF CNT > 0 THEN
            IF NOT CHECK (M, C1, SPECIES) THEN BEGIN
             INTERSECT (J, C2, SPECIES);
             IF NOT EQUAL (C1, C2, SPECIES)
             THEN BEGIN
                SPECIES := NOT SPECIES;
                INTERSECT (C1, C3, SPECIES);
                SPECIES := NOT SPECIES;
                CNT := COUNT (C3, SPECIES);
                IF CNT > LARGEST THEN LARGEST := CNT;
                IF (CNT >= MIN) AND (CNT <= MAX)
                THEN IF SPECIES THEN BEGIN
                   PRINTCHR (C3, SPECIES);
                   PRINTSPP (C1, SPECIES);
                   WRITELN;
                   END
                ELSE BEGIN
                   PRINTSPP (C3, SPECIES);
                   PRINTCHR (C1, SPECIES);
                   WRITELN;
                   END;
                END;
             IF CNT <= MAX THEN GEN (M, L, I+1, MIN, MAX, SPECIES);
             M [WORD (I)] := M [WORD (I)] + [BIT (I)];
             END;
           I := I + 1;
           END;
        END; (* GEN *)
BEGIN (* FARRIS *)
RESET(INFILE);
GETCHRSETS (SPP, CHARS, NAMES, CHRSETS);
INVERT (CHRSETS, SPPSETS);
FOR I := 1 TO WRDS DO BEGIN
   M [I] := [];
   J [I] := [];
   END;
K := 1;
SPECIES := TRUE;
MIN := 1;
MAX := CHARS;
WRITE(' ');
FOR I := 1 TO WIDTH-1 DO WRITE('-');
WRITELN;
WRITELN;
WRITELN(' GROUPS BY ORDER OF CHARACTERS ');
WRITELN;
LARGEST := 0;
GEN (M, J, K, MIN, MAX, SPECIES);
WRITE(' ');
FOR I := 1 TO WIDTH-1 DO WRITE('-');
(* CAN SPEED UP PROGRAM BY REMOVING PART FROM HERE ... *)
WRITELN;
WRITELN;
WRITELN(' GROUPS BY NUMBER OF CHARACTERS ');
WRITELN;
FOR I := LARGEST DOWNTO 1 DO BEGIN
   MIN := I;
   MAX := I;
   WRITELN;
   WRITELN(' GROUPS CONTAINING ',I:3,' CHARACTERS');
   WRITELN(' ------ ---------- --- ----------');
   WRITELN;
   GEN (M, J, K, MIN, MAX, SPECIES);
   END;
WRITE(' ');
FOR I := 1 TO WIDTH-1 DO WRITE('-');
(* ... TO HERE *)
WRITELN;
WRITELN;
WRITELN(' GROUPS BY ORDER OF SPECIES');
WRITELN;
SPECIES := FALSE;
MAX := SPP;
LARGEST := 0;
GEN (M, J, K, MIN, MAX, SPECIES);
WRITE(' ');
FOR I := 1 TO WIDTH DO WRITE('-');
(* CAN SPEED UP PROGRAM BY REMOVING PART FROM HERE ... *)
WRITELN;
WRITELN;
WRITELN(' GROUPS BY NUMBER OF SPECIES');
WRITELN;
FOR I := LARGEST DOWNTO 1 DO BEGIN
   MIN := I;
   MAX := I;
   WRITELN;
   WRITELN(' GROUPS CONTAINING ',I:3,' SPECIES');
   WRITELN(' ------ ---------- --- -------');
   WRITELN;
   GEN (M, J, K, MIN, MAX, SPECIES);
   END;
WRITE(' ');
FOR I := 1 TO WIDTH-1 DO WRITE('-');
WRITELN;
(* ... TO HERE *)
(* MAY NEED HERE -- CLOSE(INFILE); *)
END. (* FARRIS *)
